module pfcoef_inv_sqrt_class
  use pfcoef_param_class
  implicit none
  private
  public :: get_pfcoef_inv_sqrt
  real(DP), save :: minimaxerror(nkey)
  real(DP), save :: alp(nkey,0:npmax)
  real(DP), save :: bet(nkey,1:npmax)
  logical,  save :: m_is_initialized = .false.

contains

subroutine get_pfcoef_inv_sqrt(this,m,mpow)
  implicit none
  type(partial_fraction_coef), intent(inout) :: this
  integer, intent(in) :: m
  integer, intent(in) :: mpow
  integer :: ikey
  call new_pfcoef_inv_sqrt
  if (allocated(this%alp)) deallocate(this%alp)
  if (allocated(this%bet)) deallocate(this%bet)
  allocate(this%alp(0:m))
  allocate(this%bet(1:m))
  ikey = mpow + (m-npmin)*npowmax
  this%npow = mpow
  this%n    = m
  this%minimaxerror = minimaxerror(ikey)
  this%alp(0:m) = alp(ikey,0:m)
  this%bet(1:m) = bet(ikey,1:m)
  return
end subroutine

subroutine new_pfcoef_inv_sqrt()
  implicit none
  integer :: ikey,np,npow
  if (m_is_initialized) return
#include "PFcoef_InvSqrRootN04E01.dat"
#include "PFcoef_InvSqrRootN04E02.dat"
#include "PFcoef_InvSqrRootN04E03.dat"
#include "PFcoef_InvSqrRootN04E04.dat"
#include "PFcoef_InvSqrRootN04E05.dat"
#include "PFcoef_InvSqrRootN04E06.dat"
#include "PFcoef_InvSqrRootN04E07.dat"
#include "PFcoef_InvSqrRootN04E08.dat"
#include "PFcoef_InvSqrRootN05E01.dat"
#include "PFcoef_InvSqrRootN05E02.dat"
#include "PFcoef_InvSqrRootN05E03.dat"
#include "PFcoef_InvSqrRootN05E04.dat"
#include "PFcoef_InvSqrRootN05E05.dat"
#include "PFcoef_InvSqrRootN05E06.dat"
#include "PFcoef_InvSqrRootN05E07.dat"
#include "PFcoef_InvSqrRootN05E08.dat"
#include "PFcoef_InvSqrRootN06E01.dat"
#include "PFcoef_InvSqrRootN06E02.dat"
#include "PFcoef_InvSqrRootN06E03.dat"
#include "PFcoef_InvSqrRootN06E04.dat"
#include "PFcoef_InvSqrRootN06E05.dat"
#include "PFcoef_InvSqrRootN06E06.dat"
#include "PFcoef_InvSqrRootN06E07.dat"
#include "PFcoef_InvSqrRootN06E08.dat"
#include "PFcoef_InvSqrRootN07E01.dat"
#include "PFcoef_InvSqrRootN07E02.dat"
#include "PFcoef_InvSqrRootN07E03.dat"
#include "PFcoef_InvSqrRootN07E04.dat"
#include "PFcoef_InvSqrRootN07E05.dat"
#include "PFcoef_InvSqrRootN07E06.dat"
#include "PFcoef_InvSqrRootN07E07.dat"
#include "PFcoef_InvSqrRootN07E08.dat"
#include "PFcoef_InvSqrRootN08E01.dat"
#include "PFcoef_InvSqrRootN08E02.dat"
#include "PFcoef_InvSqrRootN08E03.dat"
#include "PFcoef_InvSqrRootN08E04.dat"
#include "PFcoef_InvSqrRootN08E05.dat"
#include "PFcoef_InvSqrRootN08E06.dat"
#include "PFcoef_InvSqrRootN08E07.dat"
#include "PFcoef_InvSqrRootN08E08.dat"
#include "PFcoef_InvSqrRootN09E01.dat"
#include "PFcoef_InvSqrRootN09E02.dat"
#include "PFcoef_InvSqrRootN09E03.dat"
#include "PFcoef_InvSqrRootN09E04.dat"
#include "PFcoef_InvSqrRootN09E05.dat"
#include "PFcoef_InvSqrRootN09E06.dat"
#include "PFcoef_InvSqrRootN09E07.dat"
#include "PFcoef_InvSqrRootN09E08.dat"
#include "PFcoef_InvSqrRootN10E01.dat"
#include "PFcoef_InvSqrRootN10E02.dat"
#include "PFcoef_InvSqrRootN10E03.dat"
#include "PFcoef_InvSqrRootN10E04.dat"
#include "PFcoef_InvSqrRootN10E05.dat"
#include "PFcoef_InvSqrRootN10E06.dat"
#include "PFcoef_InvSqrRootN10E07.dat"
#include "PFcoef_InvSqrRootN10E08.dat"
#include "PFcoef_InvSqrRootN11E01.dat"
#include "PFcoef_InvSqrRootN11E02.dat"
#include "PFcoef_InvSqrRootN11E03.dat"
#include "PFcoef_InvSqrRootN11E04.dat"
#include "PFcoef_InvSqrRootN11E05.dat"
#include "PFcoef_InvSqrRootN11E06.dat"
#include "PFcoef_InvSqrRootN11E07.dat"
#include "PFcoef_InvSqrRootN11E08.dat"
#include "PFcoef_InvSqrRootN12E01.dat"
#include "PFcoef_InvSqrRootN12E02.dat"
#include "PFcoef_InvSqrRootN12E03.dat"
#include "PFcoef_InvSqrRootN12E04.dat"
#include "PFcoef_InvSqrRootN12E05.dat"
#include "PFcoef_InvSqrRootN12E06.dat"
#include "PFcoef_InvSqrRootN12E07.dat"
#include "PFcoef_InvSqrRootN12E08.dat"
#include "PFcoef_InvSqrRootN13E01.dat"
#include "PFcoef_InvSqrRootN13E02.dat"
#include "PFcoef_InvSqrRootN13E03.dat"
#include "PFcoef_InvSqrRootN13E04.dat"
#include "PFcoef_InvSqrRootN13E05.dat"
#include "PFcoef_InvSqrRootN13E06.dat"
#include "PFcoef_InvSqrRootN13E07.dat"
#include "PFcoef_InvSqrRootN13E08.dat"
#include "PFcoef_InvSqrRootN14E01.dat"
#include "PFcoef_InvSqrRootN14E02.dat"
#include "PFcoef_InvSqrRootN14E03.dat"
#include "PFcoef_InvSqrRootN14E04.dat"
#include "PFcoef_InvSqrRootN14E05.dat"
#include "PFcoef_InvSqrRootN14E06.dat"
#include "PFcoef_InvSqrRootN14E07.dat"
#include "PFcoef_InvSqrRootN14E08.dat"
#include "PFcoef_InvSqrRootN15E01.dat"
#include "PFcoef_InvSqrRootN15E02.dat"
#include "PFcoef_InvSqrRootN15E03.dat"
#include "PFcoef_InvSqrRootN15E04.dat"
#include "PFcoef_InvSqrRootN15E05.dat"
#include "PFcoef_InvSqrRootN15E06.dat"
#include "PFcoef_InvSqrRootN15E07.dat"
#include "PFcoef_InvSqrRootN15E08.dat"
#include "PFcoef_InvSqrRootN16E01.dat"
#include "PFcoef_InvSqrRootN16E02.dat"
#include "PFcoef_InvSqrRootN16E03.dat"
#include "PFcoef_InvSqrRootN16E04.dat"
#include "PFcoef_InvSqrRootN16E05.dat"
#include "PFcoef_InvSqrRootN16E06.dat"
#include "PFcoef_InvSqrRootN16E07.dat"
#include "PFcoef_InvSqrRootN16E08.dat"
#include "PFcoef_InvSqrRootN17E01.dat"
#include "PFcoef_InvSqrRootN17E02.dat"
#include "PFcoef_InvSqrRootN17E03.dat"
#include "PFcoef_InvSqrRootN17E04.dat"
#include "PFcoef_InvSqrRootN17E05.dat"
#include "PFcoef_InvSqrRootN17E06.dat"
#include "PFcoef_InvSqrRootN17E07.dat"
#include "PFcoef_InvSqrRootN17E08.dat"
#include "PFcoef_InvSqrRootN18E01.dat"
#include "PFcoef_InvSqrRootN18E02.dat"
#include "PFcoef_InvSqrRootN18E03.dat"
#include "PFcoef_InvSqrRootN18E04.dat"
#include "PFcoef_InvSqrRootN18E05.dat"
#include "PFcoef_InvSqrRootN18E06.dat"
#include "PFcoef_InvSqrRootN18E07.dat"
#include "PFcoef_InvSqrRootN18E08.dat"
#include "PFcoef_InvSqrRootN19E01.dat"
#include "PFcoef_InvSqrRootN19E02.dat"
#include "PFcoef_InvSqrRootN19E03.dat"
#include "PFcoef_InvSqrRootN19E04.dat"
#include "PFcoef_InvSqrRootN19E05.dat"
#include "PFcoef_InvSqrRootN19E06.dat"
#include "PFcoef_InvSqrRootN19E07.dat"
#include "PFcoef_InvSqrRootN19E08.dat"
#include "PFcoef_InvSqrRootN20E01.dat"
#include "PFcoef_InvSqrRootN20E02.dat"
#include "PFcoef_InvSqrRootN20E03.dat"
#include "PFcoef_InvSqrRootN20E04.dat"
#include "PFcoef_InvSqrRootN20E05.dat"
#include "PFcoef_InvSqrRootN20E06.dat"
#include "PFcoef_InvSqrRootN20E07.dat"
#include "PFcoef_InvSqrRootN20E08.dat"
#include "PFcoef_InvSqrRootN21E01.dat"
#include "PFcoef_InvSqrRootN21E02.dat"
#include "PFcoef_InvSqrRootN21E03.dat"
#include "PFcoef_InvSqrRootN21E04.dat"
#include "PFcoef_InvSqrRootN21E05.dat"
#include "PFcoef_InvSqrRootN21E06.dat"
#include "PFcoef_InvSqrRootN21E07.dat"
#include "PFcoef_InvSqrRootN21E08.dat"
#include "PFcoef_InvSqrRootN22E01.dat"
#include "PFcoef_InvSqrRootN22E02.dat"
#include "PFcoef_InvSqrRootN22E03.dat"
#include "PFcoef_InvSqrRootN22E04.dat"
#include "PFcoef_InvSqrRootN22E05.dat"
#include "PFcoef_InvSqrRootN22E06.dat"
#include "PFcoef_InvSqrRootN22E07.dat"
#include "PFcoef_InvSqrRootN22E08.dat"
#include "PFcoef_InvSqrRootN23E01.dat"
#include "PFcoef_InvSqrRootN23E02.dat"
#include "PFcoef_InvSqrRootN23E03.dat"
#include "PFcoef_InvSqrRootN23E04.dat"
#include "PFcoef_InvSqrRootN23E05.dat"
#include "PFcoef_InvSqrRootN23E06.dat"
#include "PFcoef_InvSqrRootN23E07.dat"
#include "PFcoef_InvSqrRootN23E08.dat"
#include "PFcoef_InvSqrRootN24E01.dat"
#include "PFcoef_InvSqrRootN24E02.dat"
#include "PFcoef_InvSqrRootN24E03.dat"
#include "PFcoef_InvSqrRootN24E04.dat"
#include "PFcoef_InvSqrRootN24E05.dat"
#include "PFcoef_InvSqrRootN24E06.dat"
#include "PFcoef_InvSqrRootN24E07.dat"
#include "PFcoef_InvSqrRootN24E08.dat"
#include "PFcoef_InvSqrRootN25E01.dat"
#include "PFcoef_InvSqrRootN25E02.dat"
#include "PFcoef_InvSqrRootN25E03.dat"
#include "PFcoef_InvSqrRootN25E04.dat"
#include "PFcoef_InvSqrRootN25E05.dat"
#include "PFcoef_InvSqrRootN25E06.dat"
#include "PFcoef_InvSqrRootN25E07.dat"
#include "PFcoef_InvSqrRootN25E08.dat"
#include "PFcoef_InvSqrRootN26E01.dat"
#include "PFcoef_InvSqrRootN26E02.dat"
#include "PFcoef_InvSqrRootN26E03.dat"
#include "PFcoef_InvSqrRootN26E04.dat"
#include "PFcoef_InvSqrRootN26E05.dat"
#include "PFcoef_InvSqrRootN26E06.dat"
#include "PFcoef_InvSqrRootN26E07.dat"
#include "PFcoef_InvSqrRootN26E08.dat"
#include "PFcoef_InvSqrRootN27E01.dat"
#include "PFcoef_InvSqrRootN27E02.dat"
#include "PFcoef_InvSqrRootN27E03.dat"
#include "PFcoef_InvSqrRootN27E04.dat"
#include "PFcoef_InvSqrRootN27E05.dat"
#include "PFcoef_InvSqrRootN27E06.dat"
#include "PFcoef_InvSqrRootN27E07.dat"
#include "PFcoef_InvSqrRootN27E08.dat"
#include "PFcoef_InvSqrRootN28E01.dat"
#include "PFcoef_InvSqrRootN28E02.dat"
#include "PFcoef_InvSqrRootN28E03.dat"
#include "PFcoef_InvSqrRootN28E04.dat"
#include "PFcoef_InvSqrRootN28E05.dat"
#include "PFcoef_InvSqrRootN28E06.dat"
#include "PFcoef_InvSqrRootN28E07.dat"
#include "PFcoef_InvSqrRootN28E08.dat"
#include "PFcoef_InvSqrRootN29E01.dat"
#include "PFcoef_InvSqrRootN29E02.dat"
#include "PFcoef_InvSqrRootN29E03.dat"
#include "PFcoef_InvSqrRootN29E04.dat"
#include "PFcoef_InvSqrRootN29E05.dat"
#include "PFcoef_InvSqrRootN29E06.dat"
#include "PFcoef_InvSqrRootN29E07.dat"
#include "PFcoef_InvSqrRootN29E08.dat"
#include "PFcoef_InvSqrRootN30E01.dat"
#include "PFcoef_InvSqrRootN30E02.dat"
#include "PFcoef_InvSqrRootN30E03.dat"
#include "PFcoef_InvSqrRootN30E04.dat"
#include "PFcoef_InvSqrRootN30E05.dat"
#include "PFcoef_InvSqrRootN30E06.dat"
#include "PFcoef_InvSqrRootN30E07.dat"
#include "PFcoef_InvSqrRootN30E08.dat"
#include "PFcoef_InvSqrRootN31E01.dat"
#include "PFcoef_InvSqrRootN31E02.dat"
#include "PFcoef_InvSqrRootN31E03.dat"
#include "PFcoef_InvSqrRootN31E04.dat"
#include "PFcoef_InvSqrRootN31E05.dat"
#include "PFcoef_InvSqrRootN31E06.dat"
#include "PFcoef_InvSqrRootN31E07.dat"
#include "PFcoef_InvSqrRootN31E08.dat"
#include "PFcoef_InvSqrRootN32E01.dat"
#include "PFcoef_InvSqrRootN32E02.dat"
#include "PFcoef_InvSqrRootN32E03.dat"
#include "PFcoef_InvSqrRootN32E04.dat"
#include "PFcoef_InvSqrRootN32E05.dat"
#include "PFcoef_InvSqrRootN32E06.dat"
#include "PFcoef_InvSqrRootN32E07.dat"
#include "PFcoef_InvSqrRootN32E08.dat"
  m_is_initialized = .true.
  return
end subroutine

end module
