module qmxf03_module
use iso_c_binding
implicit none
public

interface

  subroutine qmx_clock(etime) bind(C)
    use iso_C_binding
    implicit none
    real(C_DOUBLE) :: etime
  end subroutine

  integer(C_INT) function qmx_get_local_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_1d_next_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_1d_prev_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_2d_local_rank_x() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_2d_local_rank_y() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_2d_next_x_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_2d_next_y_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_2d_prev_x_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  integer(C_INT) function qmx_get_2d_prev_y_rank() bind(C)
    use iso_C_binding
    implicit none
  end function

  subroutine qmx_init() bind(C)
    use iso_C_binding
    implicit none
  end subroutine

  subroutine qmx_finalize() bind(C)
    use iso_C_binding
    implicit none
  end subroutine

  subroutine qmx_barrier() bind(C)
    use iso_C_binding
    implicit none
  end subroutine

  subroutine qmx_bcast_int(size, sdat, rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    integer(C_INT)        :: sdat(size)
    integer(C_INT), value :: rank
  end subroutine

  subroutine qmx_bcast_char(size, sdat, rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    character(C_CHAR)     :: sdat(size)
    integer(C_INT), value :: rank
  end subroutine

  subroutine qmx_bcast_float(size, sdat, rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    real(C_FLOAT)         :: sdat(size)
    integer(C_INT), value :: rank
  end subroutine

  subroutine qmx_bcast_double(size, sdat, rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    real(C_DOUBLE)        :: sdat(size)
    integer(C_INT), value :: rank
  end subroutine

  subroutine qmx_bcast_cmplx(size, sdat, rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    complex(C_FLOAT)      :: sdat(size)
    integer(C_INT), value :: rank
  end subroutine

  subroutine qmx_bcast_dcmplx(size, sdat, rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    complex(C_DOUBLE)     :: sdat(size)
    integer(C_INT), value :: rank
  end subroutine

  subroutine qmx_sumcast_int(size, sdat) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    integer(C_INT)        :: sdat(size)
  end subroutine

  subroutine qmx_sumcast_char(size, sdat) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    character(C_CHAR)     :: sdat(size)
  end subroutine

  subroutine qmx_sumcast_float(size, sdat) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    real(C_FLOAT)         :: sdat(size)
  end subroutine

  subroutine qmx_sumcast_double(size, sdat) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    real(C_DOUBLE)        :: sdat(size)
  end subroutine

  subroutine qmx_sumcast_cmplx(size, sdat) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    complex(C_FLOAT)       :: sdat(size)
  end subroutine

  subroutine qmx_sumcast_dcmplx(size, sdat) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    complex(C_DOUBLE)     :: sdat(size)
  end subroutine

  subroutine qmx_sendrecv_int(size, sdat, to_rank, rdat, from_rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    integer(C_INT)        :: sdat(size)
    integer(C_INT), value :: to_rank
    integer(C_INT)        :: rdat(size)
    integer(C_INT), value :: from_rank
  end subroutine

  subroutine qmx_sendrecv_char(size, sdat, to_rank, rdat, from_rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    character(C_CHAR)     :: sdat(size)
    integer(C_INT), value :: to_rank
    character(C_CHAR)     :: rdat(size)
    integer(C_INT), value :: from_rank
  end subroutine

  subroutine qmx_sendrecv_float(size, sdat, to_rank, rdat, from_rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    real(C_FLOAT)         :: sdat(size)
    integer(C_INT), value :: to_rank
    real(C_FLOAT)         :: rdat(size)
    integer(C_INT), value :: from_rank
  end subroutine

  subroutine qmx_sendrecv_double(size, sdat, to_rank, rdat, from_rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    real(C_DOUBLE)        :: sdat(size)
    integer(C_INT), value :: to_rank
    real(C_DOUBLE)        :: rdat(size)
    integer(C_INT), value :: from_rank
  end subroutine

  subroutine qmx_sendrecv_cmplx(size, sdat, to_rank, rdat, from_rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    complex(C_FLOAT)      :: sdat(size)
    integer(C_INT), value :: to_rank
    complex(C_FLOAT)      :: rdat(size)
    integer(C_INT), value :: from_rank
  end subroutine

  subroutine qmx_sendrecv_dcmplx(size, sdat, to_rank, rdat, from_rank) bind(C)
    use iso_C_binding
    implicit none
    integer(C_INT), value :: size
    complex(C_DOUBLE)     :: sdat(size)
    integer(C_INT), value :: to_rank
    complex(C_DOUBLE)     :: rdat(size)
    integer(C_INT), value :: from_rank
  end subroutine

end interface

end module
